/*
Author : Nart Schinackow

Version : V.1.0.0

Compiler : MikroC Pro For Pic V.5.0.0.1

Description :
W5100 Is An Ethernet Module With Built In TCP/Ip Stack,
It Implements Many Protocols Tcp/UDP/ARP/....
THis Library uses Tcp The Udp Is Not Implemented Yet Soon It Will Be,
I will Support Also Client Tcp And SErver Tcp .

Hardware: A Pic With Hardware Spi


Notes:
This Library Is Tested With Pic16f877A @ 10MHZ Crystal,
Working 100%.

If Changing The Crystal You May Have To Change The CLOCK DEVIDE Int
Hardware Init Code Inside The W5100.c File

Read The W5100 Data Sheet For More Info About Timing
*/





#include "Stdio.h" //In LibStock
#include "String.h"// In LibStock
#include "IpAddress.h"// In LibStock
#include "W5100.h"// The Library Included





sfr sbit W5100_RESET at RB0_bit;
sfr sbit W5100_RESET_DIRECTION at TRISB0_bit;

sfr sbit W5100_SCS at RB1_bit;
sfr sbit W5100_SCS_DIRECTION at TRISB1_bit;

char IpBuf[4]={192,168,1,15};//device ip address
char SubBuf[4]={255,255,255,0};//device subnet mask
char GWBuf[4]={192,168,1,1};//gateway buffer
char McBuf[6]={0x00, 0x14, 0xA5, 0x76, 0x19, 0x3f};//mac buffer
char Req[20];// request buffer


const char TestPage[]=
"HTTP/1.1 200 OK\nContent-Type: text/html\n\n\
<html>\
<head>\
<title>WELCOME</title>\
<script>\
function Display()\
{\
  alert(\"Hello World!!, Its Working\");\
}\
</script>\
</head>\
<body>\
<h1 align=center>WELCOME TO TEST PAGE</h1>\
<h1 align=center><input type=\"button\" value=\"Press Me\" onclick=\"Display()\"></h1>\
</body>\
</html>";


unsigned int ConstStringLength(const char* String)// Returns The Length For A Const String
{
        unsigned int __c__;
        for(__c__=0;*String;String++)__c__++;
        return __c__;
}

void ProcessTcpRequest(char* Remote_Ip, char* Remote_Mac, unsigned int Remote_Port, unsigned int Local_port, unsigned int RequestLength)
{
   Get_Request(Req,20);// Receive The Request, Here You Could Check Your GET / AND PORT
   Write_ConstPage(TestPage,ConstStringLength(TestPage)-1); //Write The Test Page in to W5100 TX Buffer
   SendPage();//Sends The Written Page In Tx Buffer Through The Internet
}

void main() 
{
  W5100_Hardware_Init();//intialize hardware
  W5100_Init(IpBuf,SubBuf,GWBuf,McBuf);//Init W5100 Module
  UART1_Init(9600);// Initialize Uart Used For Debugging
  delay_ms(100);// Wait A Little
  


 while(1)
 {
   UpdateSocketStatus();// Update Socket
 }

}